local isondutyadmin = {}
local adminTitles = {}

RegisterNetEvent("ondutytable")
AddEventHandler("ondutytable", function(x)
    isondutyadmin = x
end)

RegisterNetEvent("returnAdminTitle")
AddEventHandler("returnAdminTitle", function(title)
    local serverId = GetPlayerServerId(PlayerId())
    adminTitles[serverId] = title
end)

Citizen.CreateThread(function()
    while true do
        TriggerServerEvent("getAdminTitle")
        Wait(15000)
    end
end)

local function DrawText3D(x, y, z, text, scl, font, colors)
    local onScreen, _x, _y = World3dToScreen2d(x, y, z)
    local px, py, pz = table.unpack(GetGameplayCamCoords())
    local dist = GetDistanceBetweenCoords(px, py, pz, x, y, z, 1)

    local scale = (1 / dist) * scl
    local fov = (1 / GetGameplayCamFov()) * 100
    scale = scale * fov

    if not colors then
        colors = {148, 0, 211}
    end

    if onScreen then
        SetTextScale(0.0 * scale, 1.1 * scale)
        SetTextFont(font or 2)
        SetTextProportional(1)
        SetTextColour(colors[1], colors[2], colors[3], 255)
        SetTextDropshadow(0, 0, 0, 0, 255)
        SetTextEdge(2, 0, 0, 0, 150)
        SetTextDropShadow()
        SetTextOutline()
        SetTextEntry("STRING")
        SetTextCentre(1)
        AddTextComponentString(text)
        DrawText(_x, _y)
    end
end

local function getNearestPlayers(radius)
    local r = {}
    for _, player in ipairs(GetActivePlayers()) do
        local distance = #(GetEntityCoords(GetPlayerPed(player)) - GetEntityCoords(PlayerPedId()))
        if distance <= radius then
            table.insert(r, player)
        end
    end
    return r
end

local nearbyPlayers = {}

Citizen.CreateThread(function()
    while true do
        Wait(1000)
        nearbyPlayers = getNearestPlayers(20.0)
    end
end)

CreateThread(function()
    while true do
        Wait(7)
        for i = 1, #nearbyPlayers do
            local ped = GetPlayerPed(nearbyPlayers[i])
            if DoesEntityExist(ped) then
                local coords = GetEntityCoords(ped)
                local serverId = GetPlayerServerId(nearbyPlayers[i])
                local adminData = isondutyadmin[serverId]

                local isVisible = IsEntityVisible(ped)
                local alpha = GetEntityAlpha(ped)

                if adminData and isVisible and alpha > 100 then
                    local title = adminTitles[serverId] or "Staff Duty"
                    DrawText3D(coords.x, coords.y, coords.z + 1.1, "~b~" .. title, 1.25, 2)
                end
            end
        end
    end
end)